TYPE t_mytype RECORD
               pkey INT,
               name VARCHAR(50)
           END RECORD
DEFINE rec t_mytype
DEFINE arr DYNAMIC ARRAY OF t_mytype

MAIN
    DEFINE where_clause STRING
    OPTIONS INPUT WRAP
    DATABASE test1
    CALL create_sql_objects()
    OPEN FORM f1 FROM "form"
    DISPLAY FORM f1
    CALL set_upshift(ui.Window.getCurrent(),"formonly.name",TRUE)
    DIALOG ATTRIBUTES(UNBUFFERED)
        CONSTRUCT BY NAME where_clause ON pkey, name
        END CONSTRUCT
        DISPLAY ARRAY arr TO sr.*
        END DISPLAY
        ON ACTION query ATTRIBUTES(TEXT="Run Query",ACCELERATOR="Return")
           DISPLAY "WHERE:", where_clause
           CALL fill_array(where_clause)
        ON ACTION exit ATTRIBUTES(TEXT="Exit")
           EXIT DIALOG
    END DIALOG
    CALL mbox_ok("Now we enter in an INPUT to check that UPSHIFT is removed")
    CALL set_upshift(ui.Window.getCurrent(),"formonly.name",FALSE)
    INPUT BY NAME rec.*
END MAIN

FUNCTION set_upshift(w,fn,on)
    DEFINE w ui.Window,
           fn STRING,
           on BOOLEAN
    DEFINE f ui.Form,
           nn, cn om.DomNode
    LET f = w.getForm()
    LET nn = f.findNode("FormField",fn)
    IF nn IS NULL THEN
       DISPLAY SFMT("ERROR: Could not find field %1", fn)
       EXIT PROGRAM 1
    END IF
    LET cn = nn.getFirstChild()
    IF on THEN
       CALL cn.setAttribute("shift", "up")
    ELSE
       CALL cn.setAttribute("shift", "none")
    END IF
END FUNCTION

FUNCTION mbox_ok(msg)
    DEFINE msg STRING
    MENU "Test" ATTRIBUTES(STYLE="dialog",COMMENT=msg)
        COMMAND "Ok" EXIT MENU
    END MENU
END FUNCTION

FUNCTION fill_array(where_clause)
    DEFINE where_clause STRING
    DEFINE x, pk INTEGER,
           sql STRING
    LET sql = "SELECT pkey FROM myview1 WHERE "||where_clause
    CALL mbox_ok(sql)
    DECLARE c1 CURSOR FROM sql
    CALL arr.clear()
    PREPARE s1 FROM "SELECT * FROM mytab1 WHERE pkey=?"
    LET x = 0
    FOREACH c1 INTO pk
        LET x = x+1
        EXECUTE s1 USING pk INTO arr[x].*
    END FOREACH
END FUNCTION

FUNCTION create_sql_objects()

    WHENEVER ERROR CONTINUE
    DROP VIEW myview1;
    DROP TABLE mytab1;
    WHENEVER ERROR STOP

    CREATE TABLE mytab1 (
               pkey INT PRIMARY KEY,
               name VARCHAR(50)
           );
    INSERT INTO mytab1 VALUES ( 101, "Phil" );
    INSERT INTO mytab1 VALUES ( 102, "PHIL" );
    INSERT INTO mytab1 VALUES ( 103, "phil" );
    INSERT INTO mytab1 VALUES ( 104, "Philip" );
    
    CREATE VIEW myview1 (pkey,name) AS SELECT pkey, UPPER(name) FROM mytab1;

END FUNCTION
